;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; filter.inc
;;
;; Copyright 1999 G. Adam Stanislav
;; All rights reserved.
;;
;; Started: 14-Nov-1999
;; Updated: 16-Nov-1999
;;
;; This is the include file for the creation of Photoshop plug-ins for Windows
;; in assembly language. It is good for both NASM and MASM.
;;
;; Producing this file using Adobe's C++ samples was real HELL!!!
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

NUMROWS	equ	64
NUMCOLS	equ	64

filterBadParameters	equ	-30100
filterBadMode	equ	-30101

; rect structure
top	equ	0
left	equ	2
bottom	equ	4
right	equ	6

; filter record
serialNumber	equ	0
abortProc	equ	serialNumber+4	; 4
progressProc	equ	abortProc+4	; 8
parameters	equ	progressProc+4	; 12
imageSize	equ	parameters+4	; 16
imageSizeX	equ	imageSize
imageSizY	equ	imageSize + 2
planes	equ	imageSize+4	; word	; 20
filterRect	equ	planes+2	; 8 bytes	22
background	equ	filterRect+8	; 6 bytes	30
foreground	equ	background+6	; 6 bytes	36
maxSpace	equ	foreground+8	; 44
bufferSpace	equ	maxSpace+4	; 48
inRect	equ	bufferSpace+4	; 8 bytes 52
inLoPlane	equ	inRect+8	; 60
inHiPlane	equ	inLoPlane+2	; 62
outRect	equ	inHiPlane+2	; 8 bytes 64
outLoPlane	equ	outRect+8	; 72
outHiPlane	equ	outLoPlane+2	; 74
inData	equ	outHiPlane+2	; pointer 76
inRowBytes	equ	inData+4	; 80
outData	equ	inRowBytes+4	; 84
outRowBytes	equ outData+4	; 88
isFloating	equ	outRowBytes+4	; 1 byte 92
haveMask	equ	isFloating+1;	; 1 byte 93
autoMask	equ	haveMask+1	; 1 byte 94
maskRect	equ	autoMask+2	; 8 bytes 96
maskData	equ	maskRect+8	; pointer 104
maskRowBytes	equ	maskData+4	; 108
backColor	equ	maskRowBytes+4	; 112
foreColor	equ	backColor+4	; 116
hostSig	equ	foreColor+4	; 120
hostProc	equ	hostSig+4	; 124
imageMode	equ	hostProc+4	; 2 bytes 128
imageHRes	equ	imageMode+4	; 132
imageVRes	equ	imageHRes+4	; 136
floatCoord	equ	imageVRes+4	; 140
wholeSize	equ	floatCoord+4	; 144
monitor	equ	wholeSize+4	; 40 bytes 148
platformData	equ	monitor+40	; 188
bufferProcs	equ	platformData+4	; 192
resourceProcs	equ	bufferProcs+4	; 196
processEvent	equ	resourceProcs+4	; 200
displayPixels	equ	processEvent+4	; 204
handleProcs	equ	displayPixels+4	; 208
supportsDummyChannels	equ	handleProcs+4	; 1 byte 212
supportsAlternateLayout	equ	supportsDummyChannels+1	; byte 213
wantLayout	equ	supportsAlternateLayout+1	; 2 bytes 214
filterCase	equ	wantLayout+2	; 2 bytes 216
dummyPlaneValue	equ	filterCase+2	; 2 bytes 218
premiereHook	equ	dummyPlaneValue+2 ; 220
advanceState	equ	premiereHook+4	; 224
